use crate::{
    prelude::*, types,
};

pub struct Null { }
impl Null {
    pub fn new() -> Self { Self { } }
}
pub fn null() -> Null { Null::new() }

impl SzunType for Null {
    fn type_id() -> usize { types::TYPE_NULL }
    fn to_ref(self) -> Ref { Ref { class:0, address:0 } }

    fn compatible<T: SzunType>(&self, _:&T) -> bool { false }

    fn __to_ref(&self) -> Ref { Ref { class:0, address:0 } }
    fn __from_ref(_:Ref) -> Self { Self { } }
}
impl Clone for Null {
    fn clone(&self) -> Self { Null::new() }
}
